#include amxmodx
#include hamsandwich

#define PLUGIN	"HL-UT sounds"
#define VERSION	"2014-01-29"
#define AUTHOR	"author unknown anonym"

#define	HLW_CROWBAR		1
#define	HLW_GLOCK		2
#define HLW_PYTHON		3
#define HLW_MP5			4
#define HLW_CROSSBOW		6
#define HLW_SHOTGUN		7
#define HLW_GAUSS		9
#define HLW_EGON		10
#define HLW_HORNETGUN		11

#define _RHI return HAM_IGNORED

static D_color, D_x, D_y, D_effect, D_fxtime, D_holdtime, D_fadeintime, D_fadeouttime, D_reliable
static maxplayers, hldmuts_cvars[22], kills[33] = {0, ...}, deaths[33] = {0, ...}
static killer_name[32], victim_name[32], r, g, b, Name[32], Host[35], crowbar, world, prepare_mode
static Float:Y_POS1 = 0.40, Float:Y_POS2 = 0.12, Float:Y_POS3 = 0.03, Float:Y_POS4 = 0.55, Float:Y_POS5 = 0.75
static weapon, hitzone, bodypart[128], frags_limit, frags, Colors, d_killed_timer[33], t_killed_timer[33], ids[32], num, m



new const levels[14] = 
{
	5, 
	10, 
	15, 
	20, 
	25, 
	30, 
	35, 
	40, 
	45, 
	50, 
	55, 
	60,
	65,
	70
}

new const levels_x2[14] = 
{
	3, 
	5, 
	7, 
	9, 
	11, 
	13, 
	15, 
	17, 
	19, 
	21, 
	23,
	25,
	27,
	29
}

new const CROWBARSOUNDLIST[2][]=
{
	"ut_misc/m_humiliation1", 
	"ut_misc/m_humiliation2"
}

new const suicide_sounds[4][]=
{
	"ut_misc/Suicide_1.wav", 
	"ut_misc/Suicide_2.wav", 
	"ut_misc/Suicide_3.wav", 
	"ut_misc/Suicide_4.wav"
}

new const m_sounds[14][] = 
{
	"ut_misc/m_multikill.wav", 
	"ut_misc/m_ultrakill.wav", 
	"ut_misc/m_monsterkill.wav", 
	"ut_misc/m_megakill.wav", 
	"ut_misc/m_ludicrouskill.wav", 
	"ut_misc/m_killingspree.wav", 
	"ut_misc/m_rampage.wav", 
	"ut_misc/m_godlike.wav", 
	"ut_misc/m_dominating.wav", 
	"ut_misc/m_unstoppable.wav", 
	"ut_misc/m_whickedsick.wav", 
	"ut_misc/m_holyshit.wav",
	"ut_misc/m_maniac.wav", 
	"ut_misc/m_killingmachine.wav"
}

new const f_sounds[14][] = 
{
	"ut_misc/f_multikill.wav", 
	"ut_misc/f_ultrakill.wav", 
	"ut_misc/f_monsterkill.wav", 
	"ut_misc/f_megakill.wav", 
	"ut_misc/f_ludicrouskill.wav", 
	"ut_misc/f_killingspree.wav", 
	"ut_misc/f_rampage.wav", 
	"ut_misc/f_godlike.wav", 
	"ut_misc/f_dominating.wav", 
	"ut_misc/f_unstoppable.wav", 
	"ut_misc/f_whickedsick.wav", 
	"ut_misc/f_holyshit.wav",
	"ut_misc/m_maniac.wav", 
	"ut_misc/m_killingmachine.wav"
}

new const ALL_PLAYERS_MSG[14][] = 
{
	"%s : Multi-Kill! (%i frags)", 
	"%s : Ultra-Kill! (%i frags)", 
	"%s : Monster-Kill! (%i frags)", 
	"%s : Mega-Kill! (%i frags)", 
	"%s : Ludicrous-Kill! (%i frags)", 
	"%s : Killing-Spree! (%i frags)", 
	"%s : Rampage! (%i frags)", 
	"%s : God-Like! (%i frags)", 
	"%s : Dominating! (%i frags)", 
	"%s : Unstoppable! (%i frags)", 
	"%s : Whicked-Sick! (%i frags)", 
	"%s : Holy-Shit! (%i frags)", 
	"%s : MANIAC! (%i frags)", 
	"%s : KILLING MACHINE! (%i frags)"
}

new const ONLY_KILLER_MSG[14][] = 
{
	"Multi-Kill - (%i frags)", 
	"Ultra-Kill - (%i frags)", 
	"Monster-Kill - (%i frags)", 
	"Mega-Kill - (%i frags)", 
	"Ludicrous-Kill! (%i frags)", 
	"Killing-Spree - (%i frags)", 
	"Rampage - (%i frags)", 
	"God-Like - (%i frags)", 
	"Dominating - (%i frags)", 
	"Unstoppable - (%i frags)", 
	"Whicked-Sick - (%i frags)", 
	"Holy-Shit - (%i frags)", 
	"MANIAC - (%i frags)", 
	"KILLING MACHINE - (%i frags)"
}

new COLORLIST[6][] = 
{
	{255,128,0}, 
	{255,255,0}, 
	{255,0,255}, 
	{0,255,0}, 
	{0,255,255}, 
	{0,150,255}
}

public plugin_init()
{
	register_plugin(PLUGIN, VERSION, AUTHOR)

	RegisterHam(Ham_Spawn, "player", "round_start", 1)
	RegisterHam(Ham_Killed, "player", "HLDMUTS", 1)

	register_event("30", "finale", "a")

	hldmuts_cvars[0] = register_cvar("hldmuts_prepare", "1")
	hldmuts_cvars[1] = register_cvar("hldmuts_firstblood", "1")
	hldmuts_cvars[2] = register_cvar("hldmuts_firstblood_mode", "1")
	hldmuts_cvars[3] = register_cvar("hldmuts_doublekill", "1")
	hldmuts_cvars[4] = register_cvar("hldmuts_doublekill_mode", "1")
	hldmuts_cvars[5] = register_cvar("hldmuts_suicide", "1")
	hldmuts_cvars[6] = register_cvar("hldmuts_crowbarkill", "1")
	hldmuts_cvars[7] = register_cvar("hldmuts_crowbarkill_mode", "1")
	hldmuts_cvars[8] = register_cvar("hldmuts_headshot", "1")
	hldmuts_cvars[9] = register_cvar("hldmuts_headshot_mode", "1")
	hldmuts_cvars[10] = register_cvar("hldmuts_welcome", "1")
	hldmuts_cvars[11] = register_cvar("hldmuts_levels", "1")
	hldmuts_cvars[12] = register_cvar("hldmuts_levels_mode", "1")
	hldmuts_cvars[13] = register_cvar("hldmuts_lmbfok", "1")
	hldmuts_cvars[14] = true
	hldmuts_cvars[15] = true
	hldmuts_cvars[16] = get_cvar_pointer("hostname")
	hldmuts_cvars[17] = get_cvar_pointer("mp_fraglimit")
	hldmuts_cvars[18] = register_cvar("mp_fraglimit", "75")
	hldmuts_cvars[19] = register_cvar("hldmuts_triplekill", "1")
	hldmuts_cvars[20] = register_cvar("hldmuts_teamkiller", "1")
	hldmuts_cvars[21] = register_cvar("hldmuts_prepare_sound", "2")

	maxplayers = get_maxplayers()
}

public finale()
{
	frags_limit = get_pcvar_num(hldmuts_cvars[17])

	get_players(ids, num, "cgh")
	
	for(m = 0; m < num; m++)
	{
		if(get_user_frags(ids[m]) == frags_limit)
		{
			message_begin(MSG_ALL, SVC_FINALE)
			write_string("")
			message_end()	
		}
	}
}

public client_connect(id)
{
	kills[id] = false
	deaths[id] = false
}

public client_putinserver(id)
{
	set_task(1.00, "Welcome", id)
}

public Welcome(id)
{
	if(is_user_connected(id) && get_pcvar_num(hldmuts_cvars[10]))
	{
		remove_task(id)

		Colors = random_num(0, 6-1)

		get_user_name(id, Name, 31)
		get_pcvar_string(hldmuts_cvars[16], Host, charsmax(Host))

		SET_DMESSAGE(COLORLIST[Colors][0], COLORLIST[Colors][1], COLORLIST[Colors][2], -1.0, 0.40, 2, 5.0, 5.0, 0.01, 0.50)
		SHOW_DMESSAGE(id, "Hello! %s^nWelcome to %s^nEnjoy playing here !", Name, Host)

		client_cmd(id, "spk ut_misc/welcome")
	}
}

public HLDMUTS(const victim, const killer, const gib) 
{
	world = read_data(4)

	if(killer == victim || killer == world || killer > maxplayers)
	{
		_SCD
		_RHI
	}

	frags_limit = get_pcvar_num(hldmuts_cvars[17]) - 3
	frags = get_user_frags(killer)

	get_user_name(killer, killer_name, 31)
	get_user_name(victim, victim_name, 31)

	get_user_attacker(victim, weapon, hitzone)

	crowbar = random_num(0, 2-1)

	Y_POS1 += 0.03
	Y_POS2 += 0.03
	Y_POS3 += 0.03
	Y_POS5 += 0.03

	if(Y_POS1 >= 0.52)
	{
		Y_POS1 = 0.40
	}
	if(Y_POS2 >= 0.18)
	{
		Y_POS2 = 0.12
	}
	if(Y_POS3 >= 0.09)
	{
		Y_POS3 = 0.03
	}

	if(Y_POS5 >= 0.81)
	{
		Y_POS5 = 0.75
	}

	switch(weapon) 
	{
		case HLW_CROWBAR: {}
		case HLW_GLOCK: {}
		case HLW_PYTHON: {}
		case HLW_MP5: {}
		case HLW_CROSSBOW: {}
		case HLW_SHOTGUN: {}	
		case HLW_GAUSS: {}
		case HLW_EGON: {}
		case HLW_HORNETGUN: {}
	}

	switch(hitzone)
	{
		case 1: bodypart = "head"
	}

	//FIRSTBLOOD
	if(hldmuts_cvars[14] && get_pcvar_num(hldmuts_cvars[1]))
	{
		if(get_cvar_num("mp_teamplay") == 1 && get_user_team(killer) == get_user_team(victim))
		{
			//do nothing ?
		}

		else

		{
			hldmuts_cvars[14] = false

			SET_DMESSAGE(255, 0, 0, -1.0, 0.65, 1, 0.01, 5.0, 0.01, 0.01)
			SHOW_DMESSAGE(0, "%s : first blood !", killer_name)

			if(get_pcvar_num(hldmuts_cvars[2]) == 1)
			{
				client_cmd(0, "spk ut_misc/m_firstblood")
			}

			else if(get_pcvar_num(hldmuts_cvars[2]) == 2)
			{
				client_cmd(0, "spk ut_misc/f_firstblood")
			}
		}
	}

	//HEADSHOT
	if(get_pcvar_num(hldmuts_cvars[8]))
	{
		if(weapon != HLW_CROWBAR && weapon && hitzone == 1)
		{
			SET_DMESSAGE(255, 128, 0, -1.00, 0.45, random_num(1, 2), 0.01, 2.0, 0.01, 0.01)
			SHOW_DMESSAGE(killer, "Head Shot :)")

			if(get_pcvar_num(hldmuts_cvars[9]) == 1)
			{
				client_cmd(killer, "spk ut_misc/m_headshot")
			}

			else if(get_pcvar_num(hldmuts_cvars[9]) == 2)
			{
				client_cmd(killer, "spk ut_misc/f_headshot")
			}

			SET_DMESSAGE(0, 255, 0, -1.00, 0.48, 1, 0.01, 2.0, 0.01, 0.01)
			SHOW_DMESSAGE(victim, "You Suck !")

			client_cmd(victim, "spk ut_misc/you_suck")
		}
	}

	//FRAGSLEFT
	if(frags_limit > 0) 
	{
		if(frags >= frags_limit) 
		{
			frags = frags_limit - frags + 3

			if(!frags)
			{
				UTIL_ScreenFade(0, {0,0,0}, 0.5, 0.0, 255, 0x0004)

				SET_DMESSAGE(0, 150, 255, -1.0, 0.38, 2, 0.01, 15.0, 0.03, 0.01)
				SHOW_DMESSAGE(0, "%s was first to reach %d frag limit !", killer_name, get_pcvar_num(hldmuts_cvars[17]))

				client_print(0, print_chat, "%s i'm winner !", killer_name)
				client_print(0, print_chat, "%s i'm the best :)", killer_name)
				client_print(0, print_chat, "%s good game :D", killer_name)

				_RHI
			}

			hldmuts_cvars[15] = false

			client_cmd(0, "spk ^"ut_misc/%ifrag%s^"", frags, frags == 1 ? "" : "s")

			SET_DMESSAGE(255, 255, 0, 0.05, Y_POS1, 2, 0.01, 4.0, 0.01, 0.01)
			SHOW_DMESSAGE(0, "%s : %i frag%s left !", killer_name, frags, frags == 1 ? "" : "s")
		}
	}

	//CROWBARKILL
	if(weapon == HLW_CROWBAR && get_pcvar_num(hldmuts_cvars[6]))
	{
		SET_DMESSAGE(200, 150, 0, -1.0, Y_POS2, 1, 0.01, 5.0, 0.01, 0.50)

		switch(get_pcvar_num(hldmuts_cvars[7]))
		{
			case 1:
			{
				SHOW_DMESSAGE(0, "%s (hewed with a crowbar) %s", killer_name, victim_name)
				client_cmd(0, "spk %s", CROWBARSOUNDLIST[crowbar])
			}
			case 2:
			{
				SHOW_DMESSAGE(killer, "You hewed with a crowbar %s", victim_name)
				client_cmd(killer, "spk %s", CROWBARSOUNDLIST[crowbar])
			}
			case 3:
			{
				SHOW_DMESSAGE(0, "%s (hewed with a crowbar) %s", killer_name, victim_name)
				client_cmd(0, "spk ut_misc/f_humiliation")
			}
			case 4:
			{
				SHOW_DMESSAGE(killer, "You hewed with a crowbar %s", victim_name)
				client_cmd(killer, "spk ut_misc/f_humiliation")
			}
		}
	}

	//DOUBLEKILL
	if(get_pcvar_num(hldmuts_cvars[3]))
	{
		if(d_killed_timer[killer])
		{
			d_killed_timer[killer] = false

			SET_DMESSAGE(200, 0, 255, -1.0, Y_POS3, 1, 0.01, 5.0, 0.01, 0.50)
			SHOW_DMESSAGE(0, "%s : DOUBLE KILL !", killer_name)

			if(get_pcvar_num(hldmuts_cvars[4]) == 1)
			{
				client_cmd(0, "spk ut_misc/m_doublekill")
			}

			else if(get_pcvar_num(hldmuts_cvars[4]) == 2)
			{
				client_cmd(0, "spk ut_misc/f_doublekill")
			}
		}

		else

		{
			d_killed_timer[killer] = true
			set_task(1.0, "d_reset_timer", killer)
		}
	}

	//TRIPLEKILL
	if(get_pcvar_num(hldmuts_cvars[19]))
	{
		if(t_killed_timer[killer] > 1)
		{
			t_killed_timer[killer] = 0
			set_task(0.5, "show_triple_kill")
		}

		else

		{
			t_killed_timer[killer]++
			set_task(2.5, "t_reset_timer", killer)
		}
	}

	//TEAMKILLER
	if(get_pcvar_num(hldmuts_cvars[20]))
	{
		if(get_cvar_num("mp_teamplay") == 1 && get_user_team(killer) == get_user_team(victim))
		{
			SET_DMESSAGE(0, 255, 0, -1.0, Y_POS5, 2, 0.01, 4.0, 0.02, 0.01)
			SHOW_DMESSAGE(0, "%s (killed team friend) %s", killer_name, victim_name)

			client_cmd(0, "spk ut_misc/m_teamkiller")
		}
	}

	//KILLSTREAK
	if(get_pcvar_num(hldmuts_cvars[11]) && hldmuts_cvars[15])
	{
		if(get_cvar_num("mp_teamplay") == 1 && get_user_team(killer) == get_user_team(victim))
		{
			_RHI
		}

  		kills[killer] += 1
  		kills[victim] = 0
  		deaths[killer] = 0
  		deaths[victim] += 1

		for(m = 0; m < 14; m++) 
		{
			if(get_pcvar_num(hldmuts_cvars[13]) == 1 && frags == levels[m])
			{
				kills_announcer(killer, m)
				_RHI
			}

			else if(get_pcvar_num(hldmuts_cvars[13]) == 2 && kills[killer] == levels_x2[m])
			{
				kills_announcer(killer, m)
				_RHI
			}
		}
	}
	_RHI
}

public d_reset_timer(id)
{
	d_killed_timer[id] = false
}

public t_reset_timer(id)
{
	t_killed_timer[id] = 0
}

public show_triple_kill()
{
	remove_task()

	SET_DMESSAGE(0, 255, 0, -1.0, 0.21, 1, 0.01, 5.0, 0.01, 0.50)
	SHOW_DMESSAGE(0, "%s : TRIPLE KILL !", killer_name)

	client_cmd(0, "spk ut_misc/m_triplekill")
}

public kills_announcer(killer, level)
{
	Y_POS4 += 0.03

	if(Y_POS4 >= 0.67)
	{
		Y_POS4 = 0.55
	}

	frags = get_user_frags(killer)

  	get_user_name(killer, killer_name, 32)

	r = random_num(0,255)
	g = random_num(0,255)
	b = random_num(0,255)

	SET_DMESSAGE(r, g, b, 0.05, Y_POS4, 2, 0.01, 4.0, 0.01, 0.50)

	switch(get_pcvar_num(hldmuts_cvars[12]))
	{
		case 1:
		{
			SHOW_DMESSAGE(0, ALL_PLAYERS_MSG[level], killer_name, frags)
  			client_cmd(0, "spk %s", m_sounds[level])
		}
		case 2:
		{
			SHOW_DMESSAGE(killer, ONLY_KILLER_MSG[level], frags)
  			client_cmd(killer, "spk %s", m_sounds[level])
		}
		case 3:
		{
			SHOW_DMESSAGE(0, ALL_PLAYERS_MSG[level], killer_name, frags)
  			client_cmd(0, "spk %s", f_sounds[level])
		}
		case 4:
		{
			SHOW_DMESSAGE(killer, ONLY_KILLER_MSG[level], frags)
  			client_cmd(killer, "spk %s", f_sounds[level])
		}
	}
}

//ROUND START
public round_start(id)
{
	prepare_mode = get_pcvar_num(hldmuts_cvars[21])

	if(prepare_mode >= 5)
	{
    		prepare_mode = random_num(1,4)
	}

	if(is_user_alive(id) && get_pcvar_num(hldmuts_cvars[0]))
	{
		SET_DMESSAGE(0, 150, 255, -1.00, 0.90, 1, 0.01, 3.0, 0.01, 0.01)

		switch(prepare_mode)
		{
			case 1:
			{
				SHOW_DMESSAGE(id, "Play !")
				client_cmd(id, "spk ut_misc/f_prepare")
			}

			case 2:
			{
				SHOW_DMESSAGE(id, "Fight !")
				client_cmd(id, "spk ut_misc/m_roundstart1")
			}

			case 3:
			{
				SHOW_DMESSAGE(id, "Play !")
				client_cmd(id, "spk ut_misc/m_roundstart2")
			}

			case 4:
			{
				SHOW_DMESSAGE(id, "Prepare to fight !")
				client_cmd(id, "spk ut_misc/m_roundstart3")
			}
		}
	}
}

//SUICIDE
stock _SCD()
{
	if(get_pcvar_num(hldmuts_cvars[5]))
	{
		SET_DMESSAGE(200, 255, 100, -1.0, 0.21, 1, 0.01, 4.0, 0.01, 0.01)
		SHOW_DMESSAGE(read_data(2), "You Are Loser !")

		client_cmd(read_data(2), "spk %s", suicide_sounds[ random_num(0, 4-1) ])
	}
}

stock SET_DMESSAGE(red = 0, green = 160, blue = 0, Float:x = -1.0, Float:y = 0.65, effects = 2, Float:fxtime = 6.0, Float:holdtime = 3.0, Float:fadeintime = 0.1, Float:fadeouttime = 1.5, bool:reliable = false)
{
	#define clamp_byte(%1) (clamp(%1,0,255))
	#define pack_color(%1,%2,%3) (%3 + (%2 << 8) + (%1 << 16))

	D_color       	= pack_color(clamp_byte(red),clamp_byte(green),clamp_byte(blue))
	D_x      	= _:x
	D_y      	= _:y
	D_effect  	= effects
	D_fxtime   	= _:fxtime
	D_holdtime  	= _:holdtime
	D_fadeintime 	= _:fadeintime
	D_fadeouttime 	= _:fadeouttime
	D_reliable	= _:reliable

	return 1
}

stock SHOW_DMESSAGE(index, const message[], any:...)
{
	static buffer[128], playersList[32], numPlayers, 
	numArguments, size

	numArguments = numargs()
	new Array:handleArrayML = ArrayCreate()
	size = ArraySize(handleArrayML)


	if(numArguments == 2)
	{
		Send_Director_Hud_Message(index, message)
	}
	else if(index || numArguments == 3)
	{
		vformat(buffer, charsmax(buffer), message, 3)
		Send_Director_Hud_Message(index, buffer)
	}
	else
	{
		get_players(playersList, numPlayers, "ch")

		if(!numPlayers)
		{
			return 0
		}

		for(new i = 2, j; i < numArguments; i++)
		{

			if(getarg(i) == LANG_PLAYER)
			{
				while((buffer[j] = getarg(i + 1, j++))){}
				j = 0

				if(GetLangTransKey(buffer) != TransKey_Bad)
				{
					ArrayPushCell(handleArrayML, i++)
				}
			}
		}
		if(!size)
		{
			vformat(buffer, charsmax(buffer), message, 3)
			Send_Director_Hud_Message(index, buffer)
		}
		else
		{
			for(new i = 0, j; i < numPlayers; i++)
			{
				index = playersList[i]

				for(j = 0; j < size; j++)
				{
					setarg(ArrayGetCell(handleArrayML, j), 0, index)
				}
				vformat(buffer, charsmax(buffer), message, 3)
				Send_Director_Hud_Message(index, buffer)
			}
		}
		ArrayDestroy(handleArrayML)
	}
	return 1
}

stock Send_Director_Hud_Message(const index, const message[])
{
	message_begin(D_reliable ?(index ? MSG_ONE : MSG_ALL) : (index ? MSG_ONE_UNRELIABLE : MSG_BROADCAST), SVC_DIRECTOR, _, index)
	{
		write_byte(strlen(message) + 31)
		write_byte(DRC_CMD_MESSAGE)
		write_byte(D_effect)
		write_long(D_color)
		write_long(D_x)
		write_long(D_y)
		write_long(D_fadeintime)
		write_long(D_fadeouttime)
		write_long(D_holdtime)
		write_long(D_fxtime)
		write_string(message)
	}
	message_end()
}

stock UTIL_ScreenFade(id=0,iColor[3]={0,0,0},Float:flFxTime=-1.0,Float:flHoldTime=0.0,iAlpha=0,iFlags=0x0000,bool:bReliable=false,bool:bExternal=false)
{
	if(id&&!is_user_connected(id))
	return

	new iFadeTime

	if(flFxTime==-1.0)
	{
		iFadeTime = 4
	}

	else

	{
		iFadeTime = FixedUnsigned16(flFxTime,1<<12)
	}

	new MSG_DEST

	if(bReliable)
	{
		MSG_DEST = id ? MSG_ONE : MSG_ALL
	}

	else

	{
		MSG_DEST = id ? MSG_ONE_UNRELIABLE : MSG_BROADCAST
	}

	if(bExternal)
	{
		emessage_begin(MSG_DEST,get_user_msgid("ScreenFade"), _,id)
		ewrite_short(iFadeTime)
		ewrite_short(FixedUnsigned16(flHoldTime,1<<12 ))
		ewrite_short(iFlags)
		ewrite_byte(iColor[0])
		ewrite_byte(iColor[1])
		ewrite_byte(iColor[2])
		ewrite_byte(iAlpha)
		emessage_end()
	}

	else

	{
		message_begin(MSG_DEST,get_user_msgid("ScreenFade"),_, id)
		write_short(iFadeTime)
		write_short(FixedUnsigned16(flHoldTime,1<<12 ))
		write_short(iFlags)
		write_byte(iColor[0])
		write_byte(iColor[1])
		write_byte(iColor[2])
		write_byte(iAlpha)
		message_end()
	}
}

stock FixedUnsigned16(Float:flValue, iScale)
{
	new iOutput

	iOutput = floatround(flValue * iScale)

	if ( iOutput < 0 )
	{
		iOutput = 0
	}

	if (iOutput > 0xFFFF)
	{
		iOutput = 0xFFFF
	}

	return iOutput
}

public plugin_precache()
{
	for(m = 0; m < 4; m++)
	precache_sound(suicide_sounds[m])

	for(m = 0; m < 14; m++)
	precache_sound(m_sounds[m])

	for(m = 0; m < 14; m++)
	precache_sound(f_sounds[m])

	precache_sound("ut_misc/1frag.wav")
	precache_sound("ut_misc/2frags.wav")
	precache_sound("ut_misc/3frags.wav")
	precache_sound("ut_misc/welcome.wav")
	precache_sound("ut_misc/you_suck.wav")
	precache_sound("ut_misc/f_firstblood.wav")
	precache_sound("ut_misc/f_headshot.wav")
	precache_sound("ut_misc/f_humiliation.wav")
	precache_sound("ut_misc/f_prepare.wav")
	precache_sound("ut_misc/f_doublekill.wav")
	precache_sound("ut_misc/m_headshot.wav")
	precache_sound("ut_misc/m_doublekill.wav")
	precache_sound("ut_misc/m_humiliation1.wav")
	precache_sound("ut_misc/m_humiliation2.wav")
	precache_sound("ut_misc/m_firstblood.wav")
	precache_sound("ut_misc/m_triplekill.wav")
	precache_sound("ut_misc/m_teamkiller.wav")
	precache_sound("ut_misc/m_roundstart1.wav")
	precache_sound("ut_misc/m_roundstart2.wav")
	precache_sound("ut_misc/m_roundstart3.wav")
}